<?php

//     
require_once 'social_bookmarking.inc.php';

class RSSFactory
{
  var $_title;
  var $_link;
  var $_description;
  var $_language;
  var $_items;

  //        XML
  function _escapeXML($str)
  {
    $translation = get_html_translation_table(HTML_ENTITIES, ENT_QUOTES);
    foreach ($translation as $key => $value)
    {
      $translation[$key] = $key; //'&#' . ord($key) . ';';
    }
    $translation[chr(38)] = '&';
    return preg_replace("/&(?![A-Za-z--]{0,4}\w{2,3};|#[0-9]{2,3};)/","&#38;",
                        strtr($str, $translation));
  }

  //         
  function RSSFactory($title, $link, $description,
                      $language = 'ru', $items = array())
  {
    //       
    $this->_title = $title;
    $this->_link = $link;
    $this->_description = $description;
    $this->_language = $language;
    $this->_items = $items;
  }

  //     
  function addItem($title, $link, $description, $additional_fields = array())
  {
    //   
    $this->_items[] =
      array_merge(array('title' => $title,
                        'link' => $link,
                        'description' => $description),
                  $additional_fields);
  }

  //  
  function get()
  {
    // 
    ob_start();
    header('Content-type: text/html');

    //   
    echo '<rss version="2.0">' .
         '<channel>' .
           '<title>' . RSSFactory::_escapeXML($this->_title) . '</title>' .
           '<link>' . RSSFactory::_escapeXML($this->_link) . '</link>' .
           '<description>' .
             RSSFactory::_escapeXML($this->_description) .
           '</description>';

    //   
    foreach ($this->_items as $feed_item)
    {
      //      
      echo '<item>';
      foreach ($feed_item as $item_name => $item_value)
      {
        //        
        if ($item_name == 'description')
        {
          //      ,    
          $social = new SocialBookmarking($feed_item['link'],
                                          $feed_item['title'],
                                          $this->_title);

          //       
          $item_value = $item_value . $social->getFeedHTML();
        }

        //   
        echo "<$item_name>" .
               RSSFactory::_escapeXML($item_value) .
             "</$item_name>";
      }
      echo '</item>';
    }

    //     RSS
    echo '</channel></rss>';

    //   
    return ob_get_clean();
  }
}

?>