<?php

//   
require_once 'config.inc.php';

//      URL
function _prepare_url_text($string)
{
  //      a-z, 0-9, ,   
  $NOT_acceptable_characters_regex = '#[^-a-zA-Z0-9_ ]#';
  $string = preg_replace($NOT_acceptable_characters_regex, '', $string);

  //     
  $string = trim($string);

  //   ,     
  $string = preg_replace('#[-_ ]+#', '-', $string);

  //   
  return $string;
}

//  ,    
function make_category_product_url($category_name, $category_id, 
                                   $product_name, $product_id)
{
  //         URL
  $clean_category_name = _prepare_url_text($category_name);
  $clean_product_name = _prepare_url_text($product_name);

  //  URL   
  $url = SITE_DOMAIN . '/Products/' . 
         $clean_category_name . '-C' . $category_id . '/' . 
         $clean_product_name . '-P' . $product_id . '.html';

  //  URL
  return $url;
}

//    
function make_media_url($id, $name, $extension)
{
  //       URL
  $clean_name = _prepare_url_text ($name);

  //  URL   
  $url = SITE_DOMAIN . '/' . $clean_name . '-M' . $id . '. ' . $extension;

  //  URL
  return $url;
}

?>