<?php

//    
class Sitemap
{
  //    URL     
  function Sitemap($items = array()) 
  {
    $this->_items = $items;
  }

  //     
  function addItem($url, 
                   $lastmod = '', 
                   $changefreq = '', 
                   $priority = '', 
                   $additional_fields = array())
  {
    $this->_items[] = array_merge(array('loc' => $url, 
                                        'lastmod' => $lastmod, 
                                        'changefreq' => $changefreq, 
                                        'priority' => $priority), 
                                  $additional_fields);
  }

  //     Google
  function getGoogle()
  {
    ob_start();
    header('Content-type: text/xml');
    echo '<?xml version="1.0" encoding="UTF-8"?>';
    echo '<urlset xmlns="http://www.google.com/schemas/sitemap/0.84">';
    foreach ($this->_items as $i)
    {
      echo '<url>';
      foreach ($i as $index => $_i) 
      {
        if (!$_i) continue;
        echo "<$index>" . $this->_escapeXML($_i) . "</$index>";
      }
      echo '</url>';
    }
    echo '</urlset>';
    return ob_get_clean();  
  }  

  //     Yahoo 
  function getYahoo()
  {
    ob_start();
    header('Content-type: text/plain');
    foreach ($this->_items as $i) 
    {
      echo $i['loc'] . "\n";
    }
    return ob_get_clean(); 
  } 

  //   ,    XML 
  function _escapeXML($str) 
  { 
    $translation = get_html_translation_table(HTML_ENTITIES, ENT_QUOTES);    
    foreach ($translation as $key => $value) 
    {
      $translation[$key] = '&#' . ord($key) . ';'; 
    }
    $translation[chr(38)] = '&';   
    return preg_replace("/&(?![A-Za-z]{0,4}\w{2,3};|#[0-9]{2,3};)/","&#38;" , 
                        strtr($str, $translation)); 
  } 
}
?>